#include "xbasic_types.h"
#include "xio.h"
#include "xintc_l.h"
#include "xuartlite_l.h"
#include "hello_video.h"

#define VGA_START 0xFEFF0200

// defined in isr.c
extern void uart_handler(void *callback);
extern void audio_handler(void *callback);
extern void my_handler(void *callback);
extern volatile char *read, *write;
extern volatile char line[BUFFER_SIZE];
extern volatile unsigned int intcounter;
extern volatile unsigned int uartcounter;
extern int mode;

unsigned char sambuf[16];
unsigned char readybuf[16];

typedef struct _ly{
  unsigned long time;
  char character;
}ly;

ly allly[2000];
int lyiter;
int size,lysize;

void setup_interrupts()
{
  XIntc_mMasterDisable(XPAR_INTC_SINGLE_BASEADDR);
  XIntc_mEnableIntr(XPAR_INTC_SINGLE_BASEADDR,0);
  XIntc_mAckIntr(XPAR_INTC_SINGLE_BASEADDR, 0xffffffff);
  XIntc_InterruptVectorTable[XPAR_INTC_MYUART_INTERRUPT_INTR].Handler = uart_handler;
  XIntc_InterruptVectorTable[XPAR_INTC_AUDIO_INTERRUPT_INTR].Handler = audio_handler;
}

int main() {
  char c,c2;
  int i,j,k,last,len,temp,offset;
  char current4[10];


  microblaze_enable_icache();

  for(i=0; i<128; i++) 
    XIo_Out32(0xFEFE0000 + i <<2 , 0);
  for( i = 0; i < W*H; i +=4  ) 
    XIo_Out32( 0x00800000 + i, 0 );

  
  setup_interrupts();
  microblaze_enable_interrupts();
  XIntc_mMasterEnable(XPAR_INTC_SINGLE_BASEADDR);
  XIntc_mEnableIntr(XPAR_INTC_SINGLE_BASEADDR, XPAR_MYUART_INTERRUPT_MASK);
  XUartLite_mEnableIntr(XPAR_MYUART_BASEADDR);

  mode=0;
  i=0;
  print("Start to get lyric\r\n");


  for( ;; ) {
    
    if( read != write ) {
      current4[i] = *read;
      
      print("size ");
      putnum(current4[i]);
      print("\r\n");
      if( read == &line[BUFFER_SIZE - 1] ) {
	read = &line[0];
      }
      else {
	read++;
      }
      i++;
    }
    if( i == 8 ) {
      break;
    }
  }
  lysize= (current4[3]<<24)&0xFF000000 | (current4[2]<<16)&0x00FF0000 | (current4[1]<<8)&0x0000FF00 |(current4[0])&0x000000FF;
  size= (current4[7]<<24)&0xFF000000 | (current4[6]<<16)&0x00FF0000 | (current4[5]<<8)&0x0000FF00 |(current4[4])&0x000000FF;

  putnum( lysize );
  print("\r\n");
  putnum( size );
  

  putnum(write-read);
  print("\r\n");
  
  
  print( "\r\ngot lyrics size\r\n" );
  
  for( i=0;i<lysize;i++ ) {
    for (j=4;j>=0;j--){
      while(read==write);
      current4[j]=*read;
      if( read == &line[BUFFER_SIZE - 1])
	read = &line[0];
      else 
	read++;
    }
    allly[i].time= (current4[1]<<24)&0xFF000000 | (current4[2]<<16)&0x00FF0000 | (current4[3]<<8)&0x0000FF00 |(current4[4])&0x000000FF;
    allly[i].character=current4[0];
    current4[1]=current4[0];
    current4[0]=' ';
    current4[2]='\r';
    current4[3]='\n';
    current4[4]=0;

    putnum(allly[i].time);
    print(current4);

  }
  print( "saved lyrics data\r\n");

  mode=1;
  XIntc_mEnableIntr(XPAR_INTC_SINGLE_BASEADDR, XPAR_AUDIO_INTERRUPT_MASK |XPAR_MYUART_INTERRUPT_MASK);  
  
  j=0,i=0,last=0,offset=0;
  while (i<lysize){
    
    
    for(k=0;k<160;k++)
      XIo_Out16(VGA_START+k,0);
    last=i;
    temp=last;
    
    for(k=i,offset=0;allly[k].character!='\r' ;k++,offset++);
    offset=(80-offset)/2;

    while(allly[i].character!='\r'){
      XIo_Out16( VGA_START + offset+i-j ,allly[i].character );
      i++;
    }

    while(allly[last].character!='\r'){
      if (last!=0){
	if (allly[last].character==' ' || temp==last ){
	  for(k=80;k<160;k++)
	    XIo_Out16(VGA_START + k,' ' );
	  len=0;
	  for(k=last+1;allly[k].character!=' ' && allly[k].character!='\r'  ;k++,len++);
	  len--;
	  
	   XIo_Out16(VGA_START + last-j+81+offset+ len/2,'\r' );
	}
      }else{
	for(k=80;k<160;k++)
	  XIo_Out16(VGA_START + k,' ' );
	for(k=last+1;allly[k].character!=' '&& allly[k].character!='\r'  ;k++,len++);
	len--;
	XIo_Out16(VGA_START + last-j+80+offset+len/2,'\r' );
      }
      while( intcounter<allly[last].time);
      intcounter=0;
      last++;
    }
   
    i++;
    j=i;
  }
  
  
  return 0;
}
